/*
 *
 *	spammerjammer.c
 *
 *	H. Morrow Long
 *
 *	$Log: spammerjammer.c,v $
 * Revision 1.2  1996/07/09  17:54:24  long
 * Fixed malloc() based on strlen() of a character array plus one bug.
 * Fixed minor compiler warnings.
 *
 * Revision 1.1  1996/05/02  21:01:22  long
 * Initial revision
 *
 * 
 *
 *
 */


#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <ctype.h>
#include <syslog.h>
#include <unistd.h>
#include <sysexits.h>

#define	RETURN_ERR	-1
#define	RETURN_FAIL	0
#define	RETURN_SUCCESS	1


#ifndef	GLOBAL_KILLFILE
#define	GLOBAL_KILLFILE "/usr/local/lib/news/killfile"
#endif

int             Debug = 0;
int             Verbose;

static int	ByteCount = 0;

static	int	NumKillLines = 0;
static	char	*KillLines[1024];

main(ArgC, ArgV)
	int             ArgC;
	char          **ArgV;
{
	int             i;
	int             Index;
	int             SubIndex;
	int             ReturnCode;
	int             ExitCode = 0;
	char		Buffer[128*1024];
	char		Buffer2[2];


	for (Index = 1; (Index < ArgC) && (ArgV[Index][0] == '-'); Index++)
	    for (SubIndex = 1; ArgV[Index][SubIndex]; SubIndex++)
		switch (ArgV[Index][SubIndex])
		{
		case 'd':
			Debug++;
			break;
		case 'v':
			Verbose++;
			break;
		default:
			(void) fprintf(stderr,
		"Usage:  spammerjammer\n");
			exit(1);
		}

	openlog("spammerjammer", LOG_PID, LOG_DAEMON);

	if ( SpammerJammer_Setup() < 0)
		{
		fprintf(stderr, 
			"%s: Error: Can't read global killfile.\n",
				 "spammerjammer" );
		syslog( LOG_INFO|LOG_LOCAL2, 
			"error: Can't read global killfile." );
		ExitCode = EX_SOFTWARE;
		}
	else
	    {
		if (Debug)
			for (i=0; i < NumKillLines; i++)
				fprintf(stderr, "KillLine[%d] = \"%s\"\n",
					i, KillLines[i] );

	    ByteCount = fread(Buffer, 1, sizeof(Buffer), stdin);
	    if (Debug)
		fprintf(stderr, "ByteCount =%d\n", ByteCount );
	    if ( ( ByteCount >= sizeof(Buffer)) && 
	        ( fread(Buffer2, 1, 1, stdin) > 0 ) )
		{
		fprintf(stderr, 
			"%s: Error: Message over maximum size of %d bytes.\n",
				 "spammerjammer", sizeof(Buffer) );
		syslog( LOG_INFO|LOG_LOCAL2, "error: msg > maxsize" );
		ExitCode = EX_DATAERR;

		}
	    else
		{
		if ( ( Index = SpammerJammer(Buffer)) > 0 )
			{
			fprintf(stderr, 
				"%s: SPAM JAMMED based on line \"%s\".\n",
				 "spammerjammer", KillLines[Index -1] );
			syslog( LOG_INFO|LOG_LOCAL2,
				"error: SPAM JAMMED based on line \"%s\".\n",
				KillLines[Index -1] );
			exit( EX_NOPERM );
			}
		ReturnCode = fwrite(Buffer, 1, ByteCount, stdout);
		if ( ReturnCode >= ByteCount )
			fflush(stdout);
		else
			{
			fprintf(stderr, "%s: Error writing %d bytes.\n",
				 "spammerjammer", ByteCount );
			if ( ReturnCode < 0 )
				{
				perror("spammerjammer: write");
				syslog(LOG_INFO|LOG_LOCAL2, 
					"error: write(): %m");
				ExitCode = EX_CANTCREAT;
				}
			else
				{
				fprintf(stderr, "%s: %d bytes written.\n",
					 "spammerjammer", ReturnCode );
				syslog( LOG_INFO|LOG_LOCAL2,
					"error: write(%d)= %d", ByteCount,
					ReturnCode );
				ExitCode = EX_IOERR;
				}
			}
			

		}
	    }
	closelog();
	fclose(stdout);
	sleep(30);
	exit(ExitCode);
}

SpammerJammer_Setup()
{
char	Line[1024];
char	NewLine[1024];
FILE	*KillFile;

	/* Downcase and shrink whitespace to one space character. */

	KillFile = (FILE *) NULL;
	if (( KillFile = fopen( GLOBAL_KILLFILE, "r" )) == (FILE *)0)
		{
		fprintf(stderr, "%s: Can't open global killfile %s.\n",
			 "spammerjammer", GLOBAL_KILLFILE );
		syslog( LOG_INFO|LOG_LOCAL2,
			"error: Can't open global killfile %s.",
			GLOBAL_KILLFILE );
		return (RETURN_FAIL);
		}
	else
	    {
	    while ( fgets ( Line, sizeof(Line) -2, KillFile )
		 != (char *)0 )
		{
		if (Debug) 
		  fprintf(stderr, "%d: Line = \"%s\" \n", NumKillLines, Line );

		Downcase_and_Shrink_Whitespace(Line, NewLine);
		if (Debug) 
		  fprintf(stderr, "After Downcase_and_Shrink_Whitespace()\n");
		KillLines[NumKillLines] = (char *) malloc( strlen(NewLine) + 1 );
		if (Debug) 
		  fprintf(stderr, "After malloc()\n");
		if (KillLines[NumKillLines] == (char *) NULL)
			{
			fprintf(stderr, "%s: Can't malloc %d bytes.\n",
				 "spammerjammer", strlen(NewLine + 1) );
			syslog( LOG_INFO|LOG_LOCAL2,
				"error: Can't malloc %d bytes.",
				strlen(NewLine + 1) );
			exit (EX_TEMPFAIL);
			}
		strcpy(KillLines[NumKillLines++], NewLine);
		if (Debug) 
			fprintf(stderr, "After strcpy()\n");

		}
/*	    if ( feof( KillFile ) )
			return(RETURN_FAIL ) ;		*/
	    fclose( KillFile );
	    return (RETURN_SUCCESS);
	    }
}

Downcase_and_Shrink_Whitespace(Line, NewLine)
char	*Line;
char	*NewLine;
{
int	LastCharWasSpace=0;
int	i, j;

/*
 *	Downcase and shrink whitespace to one space character.
 */
for ( i = 0, j=0; Line[i] && (Line[i] != '\n'); i++)
	{
	if ( isspace( Line[i]) )
		{
		if ( ! ( LastCharWasSpace ) )
		 	NewLine[j++] = ' ';
		LastCharWasSpace++;
		}
	else
		{
		NewLine[j++] = 
		  isupper( Line[i] ) ? tolower ( Line[i] ) :
		 	Line[i];
		LastCharWasSpace=0;
		}
	}
NewLine[j] = '\0';
return (RETURN_SUCCESS);
}


SpammerJammer(Buffer)
	char *Buffer;
{
	int		N;
	int		R;
	int		i;
	char		*BOLPointer = Buffer;
	char		*EOLPointer = (char *) NULL;

	while ( ( EOLPointer = index(BOLPointer, '\n') ) != (char *) NULL)
		{
		if ( ( R = Spam_Detect( BOLPointer ))  > 0 )
			return( R );
		if ( ( EOLPointer == ( Buffer + ByteCount ) ) ||
			( EOLPointer == ( Buffer + ByteCount + 1 ) ) ||
			( EOLPointer == ( Buffer + ByteCount + 2 ) ) )
			return(0);
		BOLPointer = EOLPointer +1;
		if (( *BOLPointer == '\012' ) || ( *BOLPointer == '\015' ))
			BOLPointer++;
		if ( *BOLPointer == '\0' ) 
			BOLPointer++;
		}
	return(0);
}

Spam_Detect( Line )
char	*Line;
{
char		NewLine[1024];
int		i;

	for ( i=0; i < NumKillLines; i++)
		{
		Downcase_and_Shrink_Whitespace(Line, NewLine);
		if (Debug)
			{
			fprintf(stderr, "Comparing: \n");
			fprintf(stderr, "Msg Line: \"%s\"\n", NewLine);
			fprintf(stderr, "KillLine: \"%s\"\n", KillLines[i]);
			}
		if (!( strncmp( KillLines[i], NewLine, strlen(KillLines[i]))))
			{
			if (Debug)
				fprintf(stderr, "Found match on killline %d\n",
				 i);
			return( i + 1 );
			}
		else
			if (Debug)
				fprintf(stderr,"No matching killline found.\n");
		}

	return (0);
}


